%define name bsu     
%define version 3.0.1+plplot
%define release 1
%define _prefix /usr/local

Summary:  Seismic signal processing & modeling software for Engineering Geophysics
Name: %{name}
Version: %{version}
Release: %{release}
Source: http://cgiss.boisestate.edu/~pm/%{name}-%{version}.tar.gz
Vendor: Boise State University
Packager: Paul Michaels <pm@cgiss.boisestate.edu>
URL: http://cgiss.boisestate.edu/
License: GPL
Group: Applications/Engineering
Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: blas-devel lapack-devel gsl-devel plplot-devel gcc-gfortran libgfortran  pkgconfig

%description
This package is a collection of seismic signal processing and seismic
modeling software.  It is designed for problems in Engineering Geophysics.
The binary data format is derived from SEG-Y (no reel header, 240 byte 
trace header, data).  It is very compatible with Seismic Unix, but
there are some differences in the headers (3-component recording,
polarized sources, etc.).
What is New:  This release uses gfortran for the fortran codes.
New programs have been added to the previous release, including some new
Octave programs for surface wave analysis.  Some bug fixes.  New byte
swap program to toggle Seismic Unix data sets between SUXDR (big endian)
and original little endian format.  Improved conversion to/from SEGY.


%prep
%setup -q

%build
./configure --prefix=%{_prefix} --enable-shared=no \
            --libdir=%{_prefix}/lib/bsu \
            --includedir=%{_prefix}/include/bsu  \
            --datadir=%{_prefix}/share/bsu \
	    --with-gfortran=/usr/lib/  \
            --with-plplotlib     \
            --mandir=%{_prefix}/share/man/ \
            --docdir=%{_prefix}/share/doc/bsu
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING INSTALL NEWS README 
%doc %{_prefix}/share/doc/bsu/
%{_prefix}/bin/
%{_prefix}/lib/bsu/ 
%{_prefix}/include/bsu/
%{_prefix}/share/man/man1/
%{_prefix}/share/man/man3/
%{_prefix}/share/man/man5/
%{_prefix}/share/man/man7/
%{_prefix}/share/bsu/

%changelog
* Sun Apr 08 2018 P. Michaels <pm@cgiss.boisestate.edu>
- updated both PDF and HTML documentation files.  Updated Makefile.am to reflect
- name change to bsu-user-guide3-1.pdf
- updated doc directory Octave.zip and man-bsu3-html.zip
- Many other changes from Jun 2017 to April 2018, see Changlog file in source.
* Tue Jun 13 2017 P. Michaels <pm@cgiss.boisestate.edu>
- Update BSU to 3.0.0 with Gnuplot and Plplot options
- Replaced Scilab with Octave/Matlab scripts
- New programs added, bis2seg fixed for floating point bison files
* Tue Jul 12 2010 P. Michaels <pm@cgiss.boisestate.edu>
- new program bamx.f computes amplitude decay with offset for surface waves
- Octave linkable rwv.f computes dispersion curves 
- added scilab programs for surface waves
- changes to disper.f, waves.f 
- bbox.c renamed bcar.c to avoid name clash with ps2eps program bbox
- bug fixes and reprogram bcnv.c to comply with SEGY, EBCDIC reel header and IBM floats
- added bswp.c (byte swapping program to toggle between little and big endian)
- updated documentation: bsu-user-guide2.pdf and bsu-html.tar.gz
- added new library, libIBM under C-language source for bcnv.c, IBM<==>IEEE floats
- updated bcnv man page, added bswp man page
- close(iunit1) before changing RECL (g77 permits, not permitted gfortran) on 
- bvax.f bamp.f bvas.f
- added program bnez.c, generates a survey *.nez file from a parameter description
- added hd.ofrn header in setgeom.c program, copied from SP label to integer.
- added program ba2s.c, converts ascii text to bsegy format
- Fix applied to bplt.c, corrects occasional plotting of traces outside the box.
* Thu Apr  2 2009 P. Michaels <pm@cgiss.boisestate.edu>
- First draft of the spec file
