// |$Id: fcr_labl.c,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $      |
/* |------------------------------------------------------------|
   | Basic Seismic Utilities (BSU)                              |
   | LANGUAGE: C                                                |
   | AUTHOR: P. MICHAELS    http://cgiss.boisestate.edu/~pm     | 
   | FUNCTION NAME: fcr_labl.c                                  |
   | DIRECTORY: bsu-2.0.2/src/sublibC4                          |
   |------------------------------------------------------------|
   |  NOTICE:                                                   |
   |  Copyright (C) 2017 Paul Michaels                          |
   |  <pm@cgiss.boisestate.edu>                                 |
   |  This program is free software; you can                    |
   |  redistribute it and/or modify it under the terms          |
   |  of the GNU General Public License as published            |
   |  by the Free Software Foundation; either version           |
   |  3 of the License, or (at your option) any later           |
   |  version.  This program is distributed in the              |
   |  hope that it will be useful, but                          |
   |  WITHOUT ANY WARRANTY; without even the implied            |
   |  warranty of MERCHANTABILITY or FITNESS FOR A              |
   |  PARTICULAR PURPOSE.  See the GNU General Public           |
   |  License for more details.                                 |
   |  You should have received a copy of the GNU                |
   |  General Public License along with this program;           |
   |  if not, write to the Free Software Foundation,            |
   |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
   |------------------------------------------------------------|
   |                                                            |
   | purpose: prints copyright label to listing, time           |
   |          and date                                          |
   |                                                            |
   |------------------------------------------------------------|
*/
      #include <stdio.h>
      #include <time.h>

      void fcr_labl(char pid[], FILE *h3)
     {
      int               i;
      time_t            start;
      struct tm        *ptr;

      unsigned char     b1=124,   // upper left  corner
                        b2=45,   // horizontal  bar
                        b3=124,   // vertical    bar
                        b4=124,   // upper right corner
                        b5=124,   // lower left  corner
                        b6=124;   // lower right corner
      char             *mon[12]={"Jan","Feb","Mar","Apr","May","Jun",
                                "Jul","Aug","Sep","Oct","Nov","Dec"};
//...listing header and copyright notice
      fprintf(h3,"\n %c",b1);
      for(i=0;i<40;i++) fprintf(h3,"%c",b2);
      fprintf(h3,"%c",b4);
      fprintf(h3,"\n %c",b3);
      fprintf(h3,"     Copyright (C) 2017 P. Michaels     %c",b3);
      fprintf(h3,"\n %c",b3);
      fprintf(h3,"           All rights reserved          %c",b3);
      fprintf(h3,"\n %c",b3);
      fprintf(h3,"     See GNU General Public License     %c",b3);
      fprintf(h3,"\n %c",b5);
      for(i=0;i<40;i++) fprintf(h3,"%c",b2);
      fprintf(h3,"%c\n",b6);

//...screen header and copyright notice
      printf("\n     %c",b1);
      for(i=0;i<40;i++) printf("%c",b2);
      printf("%c",b4);
      printf("\n     %c",b3);
      printf("     Copyright (C) 2017 P. Michaels     %c",b3);
      printf("\n     %c",b3);
      printf("           All rights reserved          %c",b3);
      printf("\n     %c",b3);
      printf("     See GNU General Public License     %c",b3);
      printf("\n     %c",b5);
      for(i=0;i<40;i++) printf("%c",b2);
      printf("%c\n",b6);
      printf("     %s: ",pid);

//...get time and date
      time(&start);
      ptr=localtime(&start);
      printf(" TIME: %2.2u:%2.2u:%2.2u",
         (*ptr).tm_hour,(*ptr).tm_min,(*ptr).tm_sec);
      printf(" DATE: %2.2d/%3s/%4.4d \n",
         (*ptr).tm_mday,mon[(*ptr).tm_mon],(*ptr).tm_year+1900);

      fprintf(h3," TIME: %2.2u:%2.2u:%2.2u",
         (*ptr).tm_hour,(*ptr).tm_min,(*ptr).tm_sec);
      fprintf(h3," DATE: %2.2d/%3s/%4.4d \n",
         (*ptr).tm_mday,mon[(*ptr).tm_mon],(*ptr).tm_year+1900);

     }  // end fcr_labl
