c |$Id: conv.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: conv.f                                       |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | conv:  convolves a selected filter from a bank of filters  |
c |   nt = number of points in trace                           |
c |   nf = number of points in filter                          |
c |   y  = output filtered trace                               |
c |   f  = filter array      dimension f(nf,nfil) logical      |
c |   t  = trace                                               |
c |   ifil = number of filter selected                         |
c |                                                            |
c |------------------------------------------------------------|
      subroutine conv(nt,t,nf,f,y,ifil,im)
      implicit real*4 (a-h,o-z)
      real*4 t(nt),f(im,*),y(nt)
c
      nh=(nf/2)+1
c
c...taper in
      ll=nh
      nhm1=nh-1
      k1=1
      k2=nh
      do 5 j=1,nhm1
      l=ll
      y(j)=0.0
      do 6 k=k1,k2
      y(j)=t(k)*f(l,ifil)+y(j)
      l=l-1
    6 continue
      k2=k2+1
      ll=ll+1
    5 continue
c
c...main filtering
      k1=1
      k2=nf
      jend=nt-nf+1
      j2=nh
      do 20 j=1,jend
      l=nf
      y(j2)=0.0
      do 10 k=k1,k2
      y(j2)=t(k)*f(l,ifil)+y(j2)
      l=l-1
   10 continue
      j2=j2+1
      k1=k1+1
      k2=k2+1
   20 continue
c
c...taper out
      k1=jend+1
      k2=nt
      do 30 j=1,nhm1
      l=nf
      y(j2)=0.0
      do 40 k=k1,k2
      y(j2)=t(k)*f(l,ifil)+y(j2)
      l=l-1
   40 continue
      j2=j2+1
      k1=k1+1
   30 continue
      return
      end
