c |$Id: conv2.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: conv2.f                                      |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | echo check of input parameters, writes to a history file   |
c | conv2: convolves a filter with a trace                     |
c |   nx = number of points in trace                           |
c |   nf = number of points in filter                          |
c |   y  = output filtered trace                               |
c |   f  = filter                                              |
c |   x  = input signal                                        |
c |   npz= sample number in filter corresponding to time zero  |
c --------------------------------------------------------------
c
      subroutine conv2(nx,x,nf,f,y,npz)
      implicit real*4 (a-h,o-z)
      real*4 x(*),f(*),y(*)
c
c...start output index
      j=1
c
c...taper in (assume will do loop once if npz=nf)
      do 5 jfs=npz,nf
      jf=jfs
      y(j)=0.0
      kend=npz+j-1
      do 6 k=1,kend
      y(j)=x(k)*f(jf)+y(j)
      jf=jf-1
    6 continue
      j=j+1
    5 continue
c
c...main filtering
      k1=2
      jstart=j
      jend=nx-npz+1
      do 20 j=jstart,jend
      k2=k1+nf-1
      jf=nf
      y(j)=0.0
c
      do 10 k=k1,k2
      y(j)=x(k)*f(jf)+y(j)
      jf=jf-1
   10 continue
c
      k1=k1+1
   20 continue
c
c...taper out
      jend=jend+1
      do 30 j=jend,nx
      k2=k1+nf-(j-jend)-2
      jf=nf
      y(j)=0.0
c
      do 40 k=k1,k2
      y(j)=x(k)*f(jf)+y(j)
      jf=jf-1
   40 continue
      k1=k1+1
   30 continue
      return
      end
