c |$Id: dft.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c#
c |------------------------------------------------------------|
c | Basic Seismic Utilities (BSU)                              |
c | LANGUAGE: Fortran77                                        |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: dft.f                                        |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | dft: computes discrete fourier transform (VERY SLOW)       |
c |                                                            |
c | sign = -1.0 forward transform (sum exp(-2pi*i*j*k/npts))   |
c | sign = +1.0 inverse  (1/npts)*sum exp(+2pi*i*j*k/npts))    |
c |                                                            |
c |                                                            |
c |------------------------------------------------------------|
      subroutine dft(npts,x,y,sign)
      implicit real*8 (a-h,o-z)
      complex x(npts),y(npts),w
      real*4 sign,fn
      real*8 j,k
      pi=3.14159265358979323846264338327950
      pi2=2.000000000000000*pi
      fn=float(npts)
c
c...evaluate dft
      do 5 jt=1,npts
      y(jt)=cmplx(0.0,0.0)
      j=float(jt-1)
c
      do 10 jf=1,npts
      k=float(jf-1)
      angle=(pi2*j*k*sign)/fn
      w=cmplx(dcos(angle),dsin(angle),4)
      y(jt)=y(jt)+w*x(jf)
   10 continue
c
      if(sign.gt.0.0) then
      y(jt)=y(jt)/fn
      endif
    5 continue
      return
      end
