c |$Id: polar.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: E. A. Robinson (1967, p.66)                        |
c | PROGRAM NAME: polar.f                                      |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c |------------------------------------------------------------|
c | Copyright (c) 1967 by Holden-Day Inc. 500 Sansome St.,     |
c | San Francisco, all rights reserved                         |
c |                                                            |
c | Holden-Day Inc., Liquidation Trust, 1259 S.W. 14th Street  |
c | Boca Raton, FL 33486 Phone: (561)750-9229 Fax: 561.394.6809|
c |                                                            |
c |    This subroutine is included for distribution with Basic |
c | Seismic Utilities (BSU) by joint permission of the author, |
c | Enders Robinson, and Holden-Day Inc. Liquidation Trust,    |
c | Frederick H. Murphy, Trustee.  Being part of the BSU       |
c | package, it is governed by the terms of the GPL license,   |
c | and is distributed in the hope that it will be useful, but |
c | WITHOUT ANY WARRANTY; without even the implied warranty    |
c | of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    |
c | See the GNU General Public License for more details.       |
c | Paul Michaels, February 2002 <pm@cgiss.boisestate.edu>     |
c |                                                            |
c |------------------------------------------------------------|
c |Minor modifications, Fortran IV to Fortran 77               |
c |and some other things which I needed once for use on a cray |
c |(pi variables, but I left the arithmetic IF's)  PM.         |
c |------------------------------------------------------------|
c |                      REFERENCE                             |
c | Robinson, E.A., 1967, "Multichannel Time Series Analysis   |
c |   with Digital Computer Programs", Holden-Day, 298p.       |
c |                                                            |
c |------------------------------------------------------------|
c |                                                            |
c | polar: converts from rectangular to polar coord.           |
c |                                                            |
c |------------------------------------------------------------|
      subroutine polar(npts,xr,xi,amp,phz)
      real*4 xr(*),xi(*),amp(*),phz(*)
      pi=3.14159265358979323846264338327950
      pid2=pi/2.000000000000000000000000
      do 110 i=1,npts
      amp(i)=sqrt(xr(i)*xr(i)+xi(i)*xi(i))
      if(xi(i)) 10,20,30
   10 if(xr(i)) 40,50,60
   20 if(xr(i)) 70,80,60
   30 if(xr(i)) 90,100,60
   40 phz(i)=atan(xi(i)/xr(i))-pi
      go to 110
   50 phz(i)=-pid2
      go to 110
   60 phz(i)=atan(xi(i)/xr(i))
      go to 110
   70 phz(i)=-pi
      go to 110
   80 phz(i)=0.0
      go to 110
   90 phz(i)=atan(xi(i)/xr(i))+pi
      go to 110
  100 phz(i)=pid2
  110 continue
      return
      end
