c |$Id: tlist.f,v 1.1.1.1 2017/09/16 19:19:46 pm Exp $          |
c --------------------------------------------------------------
c | Basic Seismic Utilities                                    |
c | AUTHOR: P. MICHAELS  http://cgiss.boisestate.edu/~pm       | 
c | PROGRAM NAME: tlist.f                                      |
c | DIRECTORY: bsu-2.0.2/src/sublibF4                          |
c | BugFix: kg=1 (make sure kg set to something)               |
c |------------------------------------------------------------|
c |  NOTICE:                                                   |
c |  Copyright (C) 2017 Paul Michaels                          |
c |  <pm@cgiss.boisestate.edu>                                 |
c |  This program is free software; you can                    |
c |  redistribute it and/or modify it under the terms          |
c |  of the GNU General Public License as published            |
c |  by the Free Software Foundation; either version           |
c |  3 of the License, or (at your option) any later           |
c |  version.  This program is distributed in the              |
c |  hope that it will be useful, but                          |
c |  WITHOUT ANY WARRANTY; without even the implied            |
c |  warranty of MERCHANTABILITY or FITNESS FOR A              |
c |  PARTICULAR PURPOSE.  See the GNU General Public           |
c |  License for more details.                                 |
c |  You should have received a copy of the GNU                |
c |  General Public License along with this program;           |
c |  if not, write to the Free Software Foundation,            |
c |  Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             |
c |------------------------------------------------------------|
c | tlist: lists a real trace on line printer                  |
c | Prints to io6 which is hardwired to unit 10.               |
c | (HINT: subroutines like lstprm.f typically write to unit 11|
c | so, a good idea is to set lstprm output to unit 10 if you  |
c | want to have this subroutine write to the listing file).   |
c --------------------------------------------------------------
c
      subroutine tlist(npts,x,title)
      character*1 star,cblank,y(51),dot
      real*4 x(npts)
      character*70 title
      write(star,'(''*'')')
      write(dot,'(''.'')')
      write(cblank,'('' '')')
      if(npts.le.0) return
c
c...find max and minimum values in trace
      call xmax(npts,x,fmax,fmin)
      frange=fmax-fmin
      do 5 j=1,51
    5 y(j)=cblank
      kg=1
      if(fmax.lt.0.0) kg=51
      if((fmin.gt.0.0).or.(fmax.lt.0.0)) go to 6
      gk=(-fmin)/frange
      kg=int(50.*gk+1,4)
      y(kg)=dot
    6 continue
      io6=10
      lc=0
      write(io6,900) char(12),fmax,fmin
      do 10 j=1,npts
      if(lc.lt.50) go to 7
      write(io6,902) title
  902 format(24x,53(1h.)/5x,a)
      lc=0
      write(io6,900) char(12),fmax,fmin
  900 format(a/5x,'max=',e14.7,' min=',e14.7/
     +6x,'j',12x,'x(j) ',53(1h.))
    7 continue
c
c...plot a point
      fk=(x(j)-fmin)/frange
      k=int(fk*50.+1,4)
      if(k.lt.kg) kp1=k
      if(k.ge.kg) kp1=kg+1
      if(k.le.kg) kp2=kg-1
      if(k.gt.kg) kp2=k
      do 15 jp=kp1,kp2
   15 y(jp)=star
      y(k)=star
      write(io6,901) j,x(j),(y(jk),jk=1,51)
  901 format(2x,i5,2x,e14.7,' |',51a,'|')
      lc=lc+1
c
c...restore plot line
      do 30 jp=1,51
   30 y(jp)=cblank
      if((fmin.gt.0.0).or.(fmax.lt.0.0)) go to 8
      y(kg)=dot
    8 continue
   10 continue
      write(io6,902) title
      return
      end
